quiz/urls.py
from django.conf.urls import url, include
from django.contrib import admin
from django.views.static import serve
from django.conf import settings


urlpatterns = [
    url('admin/', admin.site.urls),

    url(r'^', include(('users.urls','users'), namespace="users")),

    url(r'^app/accounts/', include('registration.backends.default.urls')),

    url(r'^media/(?P<path>.*)$', serve, { 'document_root': settings.MEDIA_ROOT}),
    url(r'^static/(?P<path>.*)$', serve, { 'document_root': settings.STATIC_FILE_ROOT}),
]

users/urls.py
from django.conf.urls import url
import users.views as views


urlpatterns = [
	url(r'^$', views.check_login, name='check_login'),
	url(r'^app/user-dashboard/$', views.dashboard, name='dashboard'),
	url(r'^app/admin-dashboard/$', views.admin_dash, name='admin_dash'),
	url(r'^users/login/$', views.user_login, name='user_login'),
	url(r'^users/register/$', views.user_register, name='user_register'),
	url(r'^users/logout/$', views.quiz_logout, name='quiz_logout'),
]

users/models.py
from __future__ import unicode_literals
from django.db import models
from django.utils.translation import ugettext_lazy as _
from django.core.validators import MinValueValidator
from decimal import Decimal
import uuid


class LessonTest(models.Model):
	user = models.ForeignKey("auth.user",on_delete=models.CASCADE)
	test_mark = models.CharField(max_length=128,blank=True,null=True)
	neg_mark = models.CharField(max_length=128,blank=True,null=True)

	class Meta:
		db_table = 'test'
		verbose_name = _('Test')
		verbose_name_plural = _('Tests')

	def __unicode__(self):
		return self.exam_type


class LessonQuestion(models.Model):
	id = models.UUIDField(primary_key=True, default=uuid.uuid4, editable=False)
	question = models.TextField()

	class Meta:
		db_table = 'question'
		verbose_name = _('Question')
		verbose_name_plural = _('Questions')

	def __str__(self):
		return str(self.question)


class LessonAnswer(models.Model):
	id = models.UUIDField(primary_key=True, default=uuid.uuid4, editable=False)
	question = models.ForeignKey("users.LessonQuestion",on_delete=models.CASCADE)
	answer = models.TextField()
	is_right_answer = models.BooleanField(default=False)
	is_deleted = models.BooleanField(default=False)

	class Meta:
		db_table = 'answer'
		verbose_name = _('Answer')
		verbose_name_plural = _('Answers')

	def __str__(self):
		return str(self.answer)

users/views.py
from django.shortcuts import render, get_object_or_404
from django.http.response import HttpResponseRedirect, HttpResponse
from django.contrib.auth.decorators import login_required
from django.urls import reverse
from users.models import LessonQuestion, LessonTest, LessonAnswer 
from users.decorators import role_required
from users.functions import get_current_role
from django.contrib.auth import logout
from django.contrib.auth import authenticate, login
from django.contrib.auth.models import User


def user_login(request):
	if request.method == 'POST':
		username = request.POST.get('username')
		password = request.POST.get('password')
		user = authenticate(username=username, password=password)

		if user is not None:
			login(request, user)
			return HttpResponseRedirect(reverse("users:dashboard"))
		else:
			return HttpResponseRedirect(reverse('users:user_login'))
	else:
		context = {

		}
		return render(request,'users/login.html', context)


def check_login(request):
	if request.user.is_superuser:
		return HttpResponseRedirect(reverse('users:admin_dash'))
	else:
		return HttpResponseRedirect(reverse('users:dashboard'))


@login_required
def quiz_logout(request):
	current_role = get_current_role(request)
	logout(request)
	if current_role == "superadmin":
		return HttpResponseRedirect(reverse('auth_login'))
	else:
		return HttpResponseRedirect(reverse('users:user_login'))


@login_required(login_url='/users/login/')
@role_required(['member'])
def dashboard(request):
	questions = LessonQuestion.objects.all()
	if request.method == 'POST':
		all_questions_attended = True
		mark = 0
		wrong = 0

		for question in questions:
			answer_pk = request.POST.get('answer_' + str(question.pk))
			if LessonAnswer.objects.filter(pk=answer_pk,question=question.pk).exists():
				
				answer = get_object_or_404(LessonAnswer.objects.filter(pk=answer_pk,question=question.pk))
				
				if answer.is_right_answer:
					mark = mark + 1	

				else:
					wrong = wrong + 1			


		if all_questions_attended:
			test = LessonTest(	
				user = request.user,		
				test_mark = mark,
				neg_mark = wrong 
			).save()

			total = mark + wrong

			context = {
				"title" : "Result",
				'mark' : mark,
				'wrong' : wrong,
				'total' : total
			}

			return render(request,'users/result.html', context)
		else:
			context = {
				"title" : "Online Exam", 
				'questions': questions
			}
			return render(request,'users/exam.html', context)

	else:
		context = {
			"title" : "Dashboard",
			'questions': questions
		}
		return render(request,'users/dashboard.html', context)


@login_required
@role_required(['superadmin'])
def admin_dash(request):
	user_tests = LessonTest.objects.all()
	is_superuser = True
	context = {
		"title" : "Result",
		'is_superuser' : is_superuser,
		'user_tests' : user_tests,
	}

	return render(request,'users/result.html', context)


def user_register(request):
	if request.method == 'POST':
		username = request.POST.get('username')
		email = request.POST.get('email')
		password1 = request.POST.get('password1')
		password2 = request.POST.get('password2')

		password =''
		error = False
		user = None
		message = ''

		if password1 == password2:
			password = password1
			error = False
		else:
			error = True

		if not error:
			user = User.objects.create_user(
				username=username,
				email=email,
				password=password
			)

			user = authenticate(username=username, password=password)
			
			if user is not None:
				login(request, user)
				return HttpResponseRedirect(reverse("users:dashboard"))
		else: 
			context = {
				message: 'both password are not same',
			}
			return render(request,'users/registration.html', context)
	else:
		context = {
		}
		return render(request,'users/registration.html', context)

templates/users/dashboard.html
{% load exam_tag %}
{% load static %}
<!DOCTYPE html>
<html>
<head>
	<link rel="shortcut icon" href="{% static 'img/favicon.ico' %}" type="image/x-icon">
	<title>Exam Application</title>
	<link rel = "stylesheet" href = "{% static 'css/style.css' %}">
	<script type="text/javascript" src="{% static 'js/jquery.min.js' %}"></script>
	<script type="text/javascript" src="{% static 'js/script.js' %}"></script>		
</head>
<body>
	<div id = "container">
		<header>			
			<h1>OBJECTIVE TYPE TEST</h1>
		</header>
		<section>			
			<form action="." class="" method="post">
				{% csrf_token %}
				<ul>
					{% for question in questions %}
					<div id="sk">
						<div class="grid">
							<li class="">
								<div class="">
									<h3>{{question.question}}</h3>							
									
									{% for answer in question|get_answers %}
								        <label for="id_{{answer.pk}}" class="btn-radio">
								          <input type="checkbox" id="id_{{answer.pk}}" name="answer_{{question.pk}}" value="{{answer.pk}}">
								          <span>{{answer}}</span>
								        </label><br>
									{% endfor %}
								</div>						
							</li>
						</div>
					</div>
					{% endfor %}
				</ul>
				<button type="submit" class="sub">Submit</button>
				<button onclick="showNext(event)" class="next button">Next</button>	
				<button onclick="showPrev(event)" class="previous button">Prev</button>
				<button class=" button skip" onclick="showNext(event)" class="previous button">Skip</button>				
				<br class="clear"/>									
			</form>			
			<br><br>
			
		</section>
		<footer>
			
		</footer>
	</div>	
</body>
</html>

templates/users/l.html
<!DOCTYPE html>
<!DOCTYPE html>
<html>
    <!--[if IE 9 ]><html class="ie9"><![endif]-->
    <head>
        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <title>Login</title>
    </head>

    <body>
        <div class="login login-content no-login-popup palette-theme {{current_theme}} bg">

        	<div class="l-block toggled" id="l-login">
			    <div class="lb-header palette-Cyan-500 bg">
			        <i class="zmdi zmdi-account-circle"></i>
			        Hi there! Please Sign in
			    </div>

			    <div class="lb-body">
			    	{% if form.non_field_errors %}
				    	<div class="palette-Red-500 text m-b-20">	    	
							{{form.non_field_errors}}			
						</div>
						<br />
					{% endif %}
					
			    	<form action="." method="post">
			    		{% csrf_token %} 
				        <div class="form-group fg-float">
				            <div class="fg-line">
				                <label class="fg-label">Email/Username</label>
				                <br />
				                <input type="text" value="" name="username" class="input-sm form-control fg-input">
				            </div>
				        </div>
				
				        <div class="form-group fg-float">
				            <div class="fg-line">
				                <label class="fg-label">Password</label>
				                <br />
				                <input name="password" value="" type="password" class="input-sm form-control fg-input">
				            </div>
				        </div>
						<input type="hidden" name="next" value="{{ next }}" />
				        <button type="submit" class="btn palette-Cyan-500 bg">Sign in</button>
					</form>
			        <div class="m-t-20">
			            <a  href="{% url 'users:user_register' %}" class="palette-Teal text">Register</a>
			        </div>
			    </div>
			</div>  
        </div>
    </body>
</html>

templates/users/login.html
<!DOCTYPE html>
<html lang="en">
<head>
<title>{{title}}</title>
{% load static %}
<meta charset="UTF-8">
<meta name="viewport" content="width=device-width, initial-scale=1">

<link rel="icon" type="image/png" href="{% static 'images/icons/favicon.ico" />

<link rel="stylesheet" type="text/css" href="{% static 'vendor/bootstrap/css/bootstrap.min.cssF">

<link rel="stylesheet" type="text/css" href="{% static 'fonts/font-awesome-4.7.0/css/font-awesome.min.css' %}">

<link rel="stylesheet" type="text/css" href="{% static 'vendor/animate/animate.css' %}">

<link rel="stylesheet" type="text/css" href="{% static 'vendor/css-hamburgers/hamburgers.min.css' %}">

<link rel="stylesheet" type="text/css" href="{% static 'vendor/select2/select2.min.css' %}">

<link rel="stylesheet" type="text/css" href="{% static 'css/util.css' %}">
<link rel="stylesheet" type="text/css" href="{% static 'css/main.css' %}">

<meta name="robots" content="noindex, follow">
</head>
<body>
	<div class="limiter">
		<div class="container-login100">
				<div class="wrap-login100">
					<div class="login100-pic js-tilt" data-tilt>
							<img src="{% static 'images/img-01.png' %}" alt="IMG">
					</div>
				<form class="login100-form validate-form" action="." method="post">
					{% csrf_token %} 
					<span class="login100-form-title">
							Student Login
					</span>
					<div class="wrap-input100 validate-input" >
						<input type="text" value="" name="username" class="input100">
						<span class="focus-input100"></span>
						<span class="symbol-input100">
							<i class="fa fa-envelope" aria-hidden="true"></i>
						</span>
					</div>
					<div class="wrap-input100 validate-input">
							<input name="password" value="" type="password" class="input100">
							<span class="focus-input100"></span>
							<span class="symbol-input100">
								<i class="fa fa-lock" aria-hidden="true"></i>
							</span>
					</div>
					<div class="container-login100-form-btn">
						<button class="login100-form-btn">
								Login
						</button>
					</div>
					<div class="text-center p-t-12">
						<span class="txt1">
							Forgot
						</span>
					<a class="txt2" href="index.html#">
						Username / Password?
					</a>
				</div>
				<div class="text-center p-t-136">
					<a class="txt2" href="{% url 'users:user_register' %}">
						Create your Account
						<i class="fa fa-long-arrow-right m-l-5" aria-hidden="true"></i>
					</a>
				</div>
			</form>
		</div>
	</div>
</div>

<script src="{% static 'vendor/jquery/jquery-3.2.1.min.js' %}"></script>

<script src="{% static 'vendor/bootstrap/js/popper.js' %}"></script>
<script src="{% static 'vendor/bootstrap/js/bootstrap.min.js' %}"></script>

<script src="{% static 'vendor/select2/select2.min.js' %}"></script>

<script src="{% static 'vendor/tilt/tilt.jquery.min.js' %}"></script>
<script>
		$('.js-tilt').tilt({
			scale: 1.1
		})
	</script>

<script async src="https://www.googletagmanager.com/gtag/js?id=UA-23581568-13"></script>
<script>
  window.dataLayer = window.dataLayer || [];
  function gtag(){dataLayer.push(arguments);}
  gtag('js', new Date());

  gtag('config', 'UA-23581568-13');
</script>

<script src="{% static 'js/main.js' %}"></script>
<script defer src="https://static.cloudflareinsights.com/beacon.min.js/v652eace1692a40cfa3763df669d7439c1639079717194" integrity="sha512-Gi7xpJR8tSkrpF7aordPZQlW2DLtzUlZcumS8dMQjwDHEnw9I7ZLyiOj/6tZStRBGtGgN6ceN6cMH8z7etPGlw==" data-cf-beacon='{"rayId":"6c437996ffd049f0","token":"cd0b4b3a733644fc843ef0b185f98241","version":"2021.12.0","si":100}' crossorigin="anonymous"></script>
</body>
</html>

templates/users/r.html
<!DOCTYPE html>
<!DOCTYPE html>
<html>
    <!--[if IE 9 ]><html class="ie9"><![endif]-->
    <head>
        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <title>Register</title>
    </head>

    <body>
		<div class="l-block toggled" id="l-login">
		    <div class="lb-header palette-Blue bg">
		        <i class="zmdi zmdi-account-circle"></i>
		        Hi there! Please Register Here
		    </div>

		    <p>{{ message }}</p>
		    <div class="lb-body">

		    	<form action="." method="post">
		    		{% csrf_token %} 
			        
			        <div class="form-group fg-float">
			            <div class="fg-line">
			                <label class="fg-label">Username</label>
			                <br />
			                <input name="username" value="" type="text" class="input-sm form-control fg-input">
			            </div>
			        </div>
			        
			        <div class="form-group fg-float">
			            <div class="fg-line">
			                <label class="fg-label">Email</label>
			                <br />
			                <input name="email" value="" type="email" class="input-sm form-control fg-input">
			            </div>
			        </div>
			        
			        <div class="form-group fg-float">
			            <div class="fg-line">
			                <label class="fg-label">Password</label>
			                <br />
			                <input name="password1" value="" type="password" class="input-sm form-control fg-input">
			            </div>
			        </div>
			        
			        <div class="form-group fg-float">
			            <div class="fg-line">
			                <label class="fg-label">Password Again</label>
			                <br />
			                <input name="password2" value="" type="password" class="input-sm form-control fg-input">
			            </div>
			        </div>
			        <input type="hidden" name="next" value="{{ next }}" />
			        
			        <button type="submit" class="btn palette-Blue bg">Register</button>
				</form>
		        <div class="m-t-20">
		            <a  class="palette-Blue text" href="{% url 'users:user_login' %}">Already have an account?</a>
		        </div>
		    </div>
		</div>  
	</body>
</html>

templates/users/registration.html
<!DOCTYPE html>
<html lang="en">
<head>
<title>{{title}}</title>
{% load static %}
<meta charset="UTF-8">
<meta name="viewport" content="width=device-width, initial-scale=1">

<link rel="icon" type="image/png" href="{% static 'images/icons/favicon.ico" />

<link rel="stylesheet" type="text/css" href="{% static 'vendor/bootstrap/css/bootstrap.min.cssF">

<link rel="stylesheet" type="text/css" href="{% static 'fonts/font-awesome-4.7.0/css/font-awesome.min.css' %}">

<link rel="stylesheet" type="text/css" href="{% static 'vendor/animate/animate.css' %}">

<link rel="stylesheet" type="text/css" href="{% static 'vendor/css-hamburgers/hamburgers.min.css' %}">

<link rel="stylesheet" type="text/css" href="{% static 'vendor/select2/select2.min.css' %}">

<link rel="stylesheet" type="text/css" href="{% static 'css/util.css' %}">
<link rel="stylesheet" type="text/css" href="{% static 'css/main.css' %}">

<meta name="robots" content="noindex, follow">
</head>
<body>
	<div class="limiter">
		<div class="container-login100">
				<div class="wrap-login100">
					<div class="login100-pic js-tilt" data-tilt>
							<img src="{% static 'images/img-01.png' %}" alt="IMG">
					</div>
				<form class="login100-form validate-form" action="." method="post">
					{% csrf_token %} 
					<span class="login100-form-title">
							Register
					</span>
					<div class="wrap-input100 validate-input" >
						<input type="text" value="" name="username" class="input100" placeholder="username">
						<span class="focus-input100"></span>
						<span class="symbol-input100">
							<i class="fa fa-user" aria-hidden="true"></i>
						</span>
					</div>
					<div class="wrap-input100 validate-input">
							<input name="email" value="" type="email" class="input100" placeholder="Email">
							<span class="focus-input100"></span>
							<span class="symbol-input100">
								<i class="fa fa-envelope" aria-hidden="true"></i>
							</span>
					</div>
					<div class="wrap-input100 validate-input">
							<input name="password1" value="" type="password" class="input100" placeholder="password">
							<span class="focus-input100"></span>
							<span class="symbol-input100">
								<i class="fa fa-lock" aria-hidden="true"></i>
							</span>
					</div>
					<div class="wrap-input100 validate-input">
							<input name="password2" value="" type="password" class="input100" placeholder="confirm password">
							<span class="focus-input100"></span>
							<span class="symbol-input100">
								<i class="fa fa-lock" aria-hidden="true"></i>
							</span>
					</div>
					<div class="container-login100-form-btn">
						<button class="login100-form-btn">
								register
						</button>
					</div>
					
				<div class="text-center p-t-136">
					<a class="txt2" href="{% url 'users:user_login' %}">
						Already Have Account
						<i class="fa fa-long-arrow-right m-l-5" aria-hidden="true"></i>
					</a>
				</div>
			</form>
		</div>
	</div>
</div>

<script src="{% static 'vendor/jquery/jquery-3.2.1.min.js' %}"></script>

<script src="{% static 'vendor/bootstrap/js/popper.js' %}"></script>
<script src="{% static 'vendor/bootstrap/js/bootstrap.min.js' %}"></script>

<script src="{% static 'vendor/select2/select2.min.js' %}"></script>

<script src="{% static 'vendor/tilt/tilt.jquery.min.js' %}"></script>
<script>
		$('.js-tilt').tilt({
			scale: 1.1
		})
	</script>

<script async src="https://www.googletagmanager.com/gtag/js?id=UA-23581568-13"></script>
<script>
  window.dataLayer = window.dataLayer || [];
  function gtag(){dataLayer.push(arguments);}
  gtag('js', new Date());

  gtag('config', 'UA-23581568-13');
</script>

<script src="{% static 'js/main.js' %}"></script>
<script defer src="https://static.cloudflareinsights.com/beacon.min.js/v652eace1692a40cfa3763df669d7439c1639079717194" integrity="sha512-Gi7xpJR8tSkrpF7aordPZQlW2DLtzUlZcumS8dMQjwDHEnw9I7ZLyiOj/6tZStRBGtGgN6ceN6cMH8z7etPGlw==" data-cf-beacon='{"rayId":"6c437996ffd049f0","token":"cd0b4b3a733644fc843ef0b185f98241","version":"2021.12.0","si":100}' crossorigin="anonymous"></script>
</body>
</html>

templates/users/result.html
{% load exam_tag %}
{% load static %}
<!DOCTYPE html>
<html>
<head>
	<link rel="shortcut icon" href="{% static 'img/favicon.ico' %}" type="image/x-icon">
	<title>{{title}}</title>
	<link rel = "stylesheet" href = "{% static 'css/style.css' %}">	
</head>
<body>
{% if not is_superuser %}

	<div id = "container">
		<header>			
			<h1>Result</h1>
		</header>
		<section>
			<div id = "results"></div>
			<table>
			  <tr>
			    <th>Your Score</th>
			    <th>Negative Mark</th>
			    <th>Total Question attended</th>
			  </tr>
			  <tr>
			    <td>{{mark}}</td>
			    <td>-{{wrong}}</td>
			    <td>{{total}}</td>
			  </tr>
		  	</table>
		</section>
		<footer>
			<p>Copyright &copy;2021, Allright Reserverd</p>
		</footer>
	</div>
{% else %}
	<div id = "container">
		<header>			
			<h1>Result</h1>
		</header>
		<section>
			<div id = "results"></div>
			<table>
			  <tr>
			    <th>Name</th>
			    <th>Mark</th>
			    
			  </tr>
			  {% for user_test in user_tests %}
				  <tr>
				    <td>{{ user_test.user.username }}</td>
					<td>{{ user_test.test_mark }}</td>
				  </tr>
			  {% endfor %}
		  	</table>
		</section>
		<footer>
			<p>Copyright &copy;2021, Allright Reserverd</p>
		</footer>
	</div>
{% endif %}
</body>
<style>
	table {
	  font-family: arial, sans-serif;
	  border-collapse: collapse;
	  width: 100%;
	}

	td, th {
	  border: 1px solid #dddddd;
	  text-align: left;
	  padding: 8px;
	}

	tr:nth-child(even) {
	  background-color: #dddddd;
	}
</style>
</html>